

const

  TastenTabelle_NORMAL : array[0..49] of Byte = (
  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R0 }
  {   1    2    3    4    5    6    7    8    9    0 }
    $31, $32, $33, $34, $35, $36, $37, $38, $39, $30,

  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R2 }
  {   q    s    d    f    g    h    j    k    l   EN }
    $71, $73, $64, $66, $67, $68, $6A, $6B, $6C, $0D,  // Vertauschung im Tastaturlayout

  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R1 }
  {   a    w    e    r    t    z    u    i    o    p }
    $61, $77, $65, $72, $74, $7A, $75, $69, $6F, $70,  // Vertauschung im Tastaturlayout

  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R3 }
  {  SH    y    x    c    v    b    n    m  TAB   SH }
    $20, $79, $78, $63, $76, $62, $6E, $6D, $09, $20,

  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R4 }
  {  CT    <    >    ?    *    ;    -    :   SP   CT }
    $20, $3C, $3E, $3F, $2A, $3B, $2D, $3A, $20, $20

    );



  TastenTabelle_SHIFT : array[0..49] of Byte = (
  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R0 }
  {   !    "    #    $    %    &    /    (    )    = }
    $21, $22, $23, $24, $25, $26, $2F, $28, $29, $3D,

  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R2 }
  {   q    s    d    f    g    h    j    k    l   EN }
    $51, $53, $44, $46, $47, $48, $4A, $4B, $4C, $0D,  // Vertauschung im Tastaturlayout

  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R1 }
  {   a    w    e    r    t    z    u    i    o    p }
    $41, $57, $45, $52, $54, $5A, $55, $49, $4F, $50,  // Vertauschung im Tastaturlayout

  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R3 }
  {  SH    y    x    c    v    b    n    m  TAB   SH }
    $20, $59, $58, $43, $56, $42, $4E, $4D, $09, $20,

  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R4 }
  {  CT   KA   KZ    #    +    ,    _    .   SP   CT }
    $20, $7B, $7D, $23, $2B, $2C, $5F, $2E, $20, $20

    );





  TastenTabelle_CTRL : array[0..49] of Byte = (
  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R0 }
  {   |    ^    '    `    ~    6    \    8    9    0 }
    $7C, $5E, $27, $60, $7E, $36, $5C, $38, $39, $30,

  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R2 }
  {   q    s    d    f    g    h    j    k    l   EN }
    $11, $13, $04, $06, $07, $08, $0A, $0B, $0C, $0D,  // Vertauschung im Tastaturlayout

  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R1 }
  {   a    w    e    r    t    z    u    i    o    p }
    $01, $17, $05, $12, $14, $1A, $15, $09, $0F, $10,  // Vertauschung im Tastaturlayout

  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R3 }
  {  SH    y    x    c    v    b    n    m  TAB   SH }
    $20, $19, $18, $03, $16, $02, $0E, $0D, $09, $20,

  {  S0   S1   S2   S3   S4   S5   S6   S7   S8   S9 - R4 }
  {  CT    [    ]    @  ESC  BSP  INS  DEL   SP   CT }
    $20, $5B, $5D, $40, $1B, $08, $16, $7F, $20, $20

    );


  max_Tasten_Nummer_plus_eins : Byte = 50;


var
  WD_Word : Word;

  // Puffer fuer die (aus dem SCAN-Code konvertierten) Tasten-Bytes
  KeyBuffer      : array [0..32] of Byte;
  KeyBufferPtr   : Word;

  Tasten_Nummer,
  letzte_Tasten_Nummer,
  Entprell_Zaehler : Byte;

  Text_String : String[15];

  SHIFT_ist_aktiv,
  CTRL_ist_aktiv : Boolean;




procedure KBD_Init;
begin

  // alle Steuerleitungen auf low
  ClearBit(SERIAL_DATA);
  ClearBit(SHIFT_CLOCK);
  ClearBit(LATCH_CLOCK);

  Status_LED_SHIFT_GN1:=false;
  Status_LED_SHIFT_GN2:=false;

  Status_LED_CTRL_BL1:=false;
  Status_LED_CTRL_BL2:=false;

  KeyBufferPtr:=0;
  letzte_Tasten_Nummer:=max_Tasten_Nummer_plus_eins+1;

  SHIFT_ist_aktiv:=false;
  CTRL_ist_aktiv:=false;

end KBD_Init;






// *** Unterprogramme zum key-Buffer ***




function read_key : Byte;
var
  read_key_value : Byte;
  key_counter : Word;
  b1 : Byte;
begin

  if KeyBufferPtr>0 then

    read_key_value:=KeyBuffer[0];
    dec(KeyBufferPtr);

    for key_counter:=0 to KeyBufferPtr do
      b1 := KeyBuffer[key_counter+1];
      KeyBuffer[key_counter] := b1;
    endfor;

  else

    read_key_value:=0;

  endif;

  Result:=read_key_value;

end read_key;





procedure write_key(write_key_value : byte);
begin

  KeyBuffer[KeyBufferPtr]:=write_key_value;

  if KeyBufferPtr<32 then
    inc(KeyBufferPtr);
  endif;

end write_key;







procedure write_c_key(cKey : char);
var
  b1 : Byte;
begin
  b1:=CharToByte(cKey);
  write_key(b1);
end write_c_key;




procedure write_text;
var
  Zaehler : Byte;
  c1 : Char;
begin
  for zaehler:=1 to length(Text_String) do
    c1:=Text_String[Zaehler];
    write_c_key(c1);
  endfor;
end write_text;






// ***************************************







procedure Write_Data_Word;
var
  R_Word_Latch : Word;
  R_counter : Byte;
begin

  for R_counter:=1 to 14 do

    ClearBit(SHIFT_CLOCK);

    R_Word_Latch:=WD_Word and %0000000000000001;

    if R_Word_Latch=0 then
      ClearBit(SERIAL_DATA);  // Data-Bit=0
    else
      SetBit(SERIAL_DATA); // Data-Bit=1
    endif;

    // Shift IN Data-Bit
    SetBit(SHIFT_CLOCK);

    SHR(WD_Word);

  endfor; { for R_counter:=1 to 16 do }

  SetBit(LATCH_CLOCK);
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  NOP;
  ClearBit(LATCH_CLOCK);


end Write_Data_Word;











procedure TastenNummer_zu_TastenZeichen;
var
  Tasten_Zeichen : Byte;
  TN_Word : Word;
begin

  Tasten_Zeichen:=0;

  if BitLow(TAST_SW_SHIFT) then
    SHIFT_ist_aktiv:=true;
    Status_LED_SHIFT_GN1:=true;
    Status_LED_SHIFT_GN2:=true;
  else
    SHIFT_ist_aktiv:=false;
    Status_LED_SHIFT_GN1:=false;
    Status_LED_SHIFT_GN2:=false;
  endif;


  if BitLow(TAST_SW_CTRL) then
    CTRL_ist_aktiv:=true;
    Status_LED_CTRL_BL1:=true;
    Status_LED_CTRL_BL2:=true;
  else
    CTRL_ist_aktiv:=false;
    Status_LED_CTRL_BL1:=false;
    Status_LED_CTRL_BL2:=false;
  endif;



  TN_Word:=ByteToWord(Tasten_Nummer);

  if SHIFT_ist_aktiv then
    Tasten_Zeichen:=TastenTabelle_SHIFT[TN_Word];
    SHIFT_ist_aktiv:=false;
    Status_LED_SHIFT_GN1:=false;
    Status_LED_SHIFT_GN2:=false;
  else

    if CTRL_ist_aktiv then
      Tasten_Zeichen:=TastenTabelle_CTRL[TN_Word];
      CTRL_ist_aktiv:=false;
      Status_LED_CTRL_BL1:=false;
      Status_LED_CTRL_BL2:=false;
    else
      Tasten_Zeichen:=TastenTabelle_NORMAL[TN_Word];
    endif;

  endif;


  if Tasten_Zeichen>0 then
    write_key(Tasten_Zeichen);
  endif;

end TastenNummer_zu_TastenZeichen;












procedure Anzeige_Status_LEDs;
begin

  if Status_LED_SHIFT_GN1 then
    WD_Word:=WD_Word or  %0000000000001000;
  else
    WD_Word:=WD_Word and %1111111111110111;
  endif;

  if Status_LED_SHIFT_GN2 then
    WD_Word:=WD_Word or  %0000000000000100;
  else
    WD_Word:=WD_Word and %1111111111111011;
  endif;

  if Status_LED_CTRL_BL1 then
    WD_Word:=WD_Word or  %0000000000000010;
  else
    WD_Word:=WD_Word and %1111111111111101;
  endif;

  if Status_LED_CTRL_BL2 then
    WD_Word:=WD_Word or  %0000000000000001;
  else
    WD_Word:=WD_Word and %1111111111111110;
  endif;

  Write_Data_Word;

end Anzeige_Status_LEDs;







procedure Tastatur_lesen;
var
  w2 : Byte;
begin

  Tasten_Nummer:=max_Tasten_Nummer_plus_eins;

  for w2:=0 to 9 do

    case w2 of

      00 : WD_Word:=%0001111111110000;
      |

      01 : WD_Word:=%0010111111110000;
      |

      02 : WD_Word:=%0011011111110000;
      |

      03 : WD_Word:=%0011101111110000;
      |

      04 : WD_Word:=%0011110111110000;
      |

      05 : WD_Word:=%0011111011110000;
      |

      06 : WD_Word:=%0011111101110000;
      |

      07 : WD_Word:=%0011111110110000;
      |

      08 : WD_Word:=%0011111111010000;
      |

      09 : WD_Word:=%0011111111100000;
      |


    endcase;

    Anzeige_Status_LEDs;

    if BitLow(TAST_R0) then
      Tasten_Nummer:=w2;
    endif;

    if BitLow(TAST_R1) then
      Tasten_Nummer:=w2+10;
    endif;

    if BitLow(TAST_R2) then
      Tasten_Nummer:=w2+20;
    endif;

    if BitLow(TAST_R3) then
      Tasten_Nummer:=w2+30;
    endif;

    if BitLow(TAST_R4) then
      Tasten_Nummer:=w2+40;
    endif;

  endfor;

  // Entprellung !!!

  if Tasten_Nummer=letzte_Tasten_Nummer then

    if Entprell_Zaehler>0 then

      Dec(Entprell_Zaehler);

      if Entprell_Zaehler=1 then

        if Tasten_Nummer<max_Tasten_Nummer_plus_eins then
          TastenNummer_zu_TastenZeichen;
          Click;
        endif;

      endif;

    endif;

  else
    // hier Aenderung der Taste (Taste gedrueckt oder losgelassen)
    letzte_Tasten_Nummer:=Tasten_Nummer;
    Entprell_Zaehler:=10;
  endif;




end Tastatur_lesen;


















